package cz.cvut.fel.pr1;

import java.awt.Point;
import java.util.Scanner;

class Lab09 {
    
    Scanner scan = new Scanner(System.in);
    
    // =========================================================================
    // ======= PART 1 ==========================================================
    // =========================================================================
    public void computeFactorial() {
        final int LIMIT = 1000; // increase the limit to see stack overflow
        System.out.println("Enter a positive integer number < " + LIMIT);
        
        if (scan.hasNextInt()) {
            final int val = scan.nextInt();
            if (val >= 0 && val <= LIMIT) {
                
                double result = factorial(val);
                
                System.out.println("Factorial of " + val + " = " + result);
            } else {
                System.err.println("Given number is out of range");
            }
        } else {
            System.err.println("It is not an integer number");
        }
    }
    
    private double factorial(int number) {
        if (number <= 1) return 1;
        else return number * factorial(number - 1);
    }
    
    // =========================================================================
    // ======= PART 2 ==========================================================
    // =========================================================================
    public void printStars() {
        printStars(10);
    }
    
    private void printStars(int number) {
        
        // TODO: write your code
        
    }
    
    // =========================================================================
    // ======= PART 3 ==========================================================
    // =========================================================================
    public void computeFibonacci() {
        final int LENGTH = 10;
        for (int i = 1; i <= LENGTH; i++) {
            System.out.println(" " + fibonacci(i));
        }
        
        long tic, toc;
        tic = System.currentTimeMillis();
        fibonacci(40);
        toc = System.currentTimeMillis();
        
        System.out.println("\nRecursion - time elapsed: " + (toc - tic) + " ms");
        
        tic = System.currentTimeMillis();
        fibonacciIter(40);
        toc = System.currentTimeMillis();
        
        System.out.println("\nIteraion - time elapsed: " + (toc - tic) + " ms");

    }
    
    private int fibonacci(int number) {
        
        // TODO: write your code
        
        return 0;
    }
    
    private int fibonacciIter(int number) {
        int fibM2 = 1;
        int fibM1 = 1;
        int fib = 1;
        for (int i = 2; i <= number; ++i) {
            fibM2 = fibM1;
            fibM1 = fib;
            fib = fibM1 + fibM2;
        }
        return fib;
    }
    
    // =========================================================================
    // ======= PART 4 ==========================================================
    // =========================================================================
    public void testPalindrom() {
        System.out.println("Enter a palindrom: ");
        String str = scan.next();
        
        System.out.println("The input text is " + (isPalindrom(str) ? "" : "NOT ") + "a palindrom.");
    }

    private boolean isPalindrom(String str) {
        
        // TODO: write your code
        
        return false;
    }
    
    // =========================================================================
    // ======= PART 5 ==========================================================
    // =========================================================================
    int counter = 0;

    public void solveHanoi() {
        System.out.print("Enter the tower's height: ");
        int height = scan.nextInt();
        
        if (height < 1) System.out.println("The height has to be at least 1!");
        else {
            System.out.println("Solution - the sequence of moves:");
            moveTower(height, 1, 2, 3);
        }
    }

    private void moveTower(int numberOfDiscs, int from, int to, int temp) {
        
        // TODO: write your code
        
    }
    
    // =========================================================================
    // ======= PART 6 ==========================================================
    // =========================================================================
    public void computeApproximations() {
        for (int i = 0; i < 40; i++) {
            System.out.println("The golden ratio = " + computeGoldenRatio(i));
        }
        for (int i = 0; i < 20; i++) {
            System.out.println("The euler's number = " + computeEulersNumber(i));
        }
    }

    private double computeGoldenRatio(int precision) {
        
        // TODO: write your code
        
        return 0.0;
    }
    
    private double computeEulersNumber(int precision) {
        
        // TODO: write your code
        
        return 0.0;
    }
    
    // =========================================================================
    // ======= PART 7 ==========================================================
    // =========================================================================
    String characters = "0123456789ABCDEFGHIJKLMNOPRSTUVWXYZ";
    
    public void convertNumber() {
        printConversion(13, 2);
        System.out.println();
    }

    private void printConversion(int number, int system) {
        
        // TODO: write your code
        
    }
    
    // =========================================================================
    // ======= PART 8 ==========================================================
    // =========================================================================
    public void runMinesweeper() {
        Minesweeper ms = new Minesweeper();
        
        Point p = new Point(2, 5);
        ms.clickOn(p);
        
        ms.viewBoard();
        ms.checkWin();
    }
    
    // =========================================================================
    // =========================================================================
    // =========================================================================

    public void start(String[] args) {
        final int DEFAULT_PART = 1;
        int PART = 0;
        
        if (args.length > 0) {
            if (args[0].matches("[0-9]+")) {
                PART = Integer.parseInt(args[0]);
            }
        } else {
            PART = DEFAULT_PART;
        }
        
        switch (PART) {
            case 1: computeFactorial(); break;
            case 2: printStars(); break;
            case 3: computeFibonacci(); break;
            case 4: testPalindrom(); break;
            case 5: solveHanoi(); break;
            case 6: computeApproximations(); break;
            case 7: convertNumber(); break;
            case 8: runMinesweeper(); break;
            default: System.err.println("Usage: first argument is [1-8]");
        }
    }
}
