package cz.cvut.fel.pr1;

import java.awt.Point;

public class MineField {
    
    public final int SIZE;
    
    private final boolean[][] mines;
    private final int[][] labels;
    private final boolean[][] alreadyClicked;
    
    public MineField(int size) {
        SIZE = size;
        // There's a 1 tile wide soft border, the fields have thus [size + 2]
        mines = new boolean[size + 2][size + 2];
        labels = new int[size + 2][size + 2];
        alreadyClicked = new boolean[size + 2][size + 2];
    }
    
    public boolean isBombAt(Point p) {return isBombAt(p.x, p.y);}
    public boolean isBombAt(int x, int y) {return mines[x][y];}
    
    public boolean isRevealed(Point p) {return isRevealed(p.x, p.y);}
    public boolean isRevealed(int x, int y) {return alreadyClicked[x][y];}
    
    public void markAsRevealed(Point p) {markAsRevealed(p.x, p.y);}
    public void markAsRevealed(int x, int y) {alreadyClicked[x][y] = true;}
    
    public int getNumberOfMinesNear(Point p) {return getNumberOfMinesNear(p.x, p.y);}
    public int getNumberOfMinesNear(int x, int y) {return labels[x][y];}
    
    public void setMineAt(Point p, boolean mine) {setMineAt(p.x, p.y, mine);}
    public void setMineAt(int x, int y, boolean mine) {mines[x][y] = mine;}
    
    public void setLabetAt(Point p, int numberOfMines) {setLabetAt(p.x, p.y, numberOfMines);}
    public void setLabetAt(int x, int y, int numberOfMines) {labels[x][y] = numberOfMines;}    
}
